]> code.delx.au - transcoding/blobdiff - fix-pal-speedup
fix-pal-speedup: don't try to adjust chapter-sync if there are zero chapters
[transcoding] / fix-pal-speedup
index edac6642c8888e8b2b75e7954a37a3443cbedfa5..51ab6ed52fcacf4742c489eec58bc2cc458aaaf5 100755 (executable)
@@ -1,39 +1,90 @@
-#!/bin/bash -e
+#!/bin/bash
 
-# Many DVDs released in Australia are sped up from 23.976fps to 25fps.
+# Many DVDs released in Australia are sped up from 24fps to 25fps.
 # This script reverses the procedure, correcting the audio pitch.
-# Input files are assumed to be mkv files with track 2 audio.
-# The video framerate is adjusted without re-encoding. The audio is slowed and
-# normalised then re-encoded as mp3.
+# - The video framerate is adjusted without re-encoding.
+# - The audio is slowed, and encoded as AAC, preserving surround sound.
+# - Chapters and subtitles are also adjusted to match the new timing.
 
-if [ -z "$1" -o -z "$2" ]; then
-       echo "Usage: $0 destdir infile"
-       exit 1
+if [ -z "$1" ] || [ -z "$2" ]; then
+    echo "Usage: $0 infile outfile"
+    exit 1
 fi
 
-# FORCEFPS = 24000 / 1001
-# SLOWDOWN = FORCEFPS / 25
-FORCEFPS="23.976023976023978"
-SLOWDOWN="0.9590409590409591"
+set -o pipefail -eux
+OLDFPS="25"
+NEWFPS="24"
+SLOWFILTER=("-filter" "asetrate=46080,aresample=osr=48000:resampler=soxr")
 
-destdir="$1"
-infile="$2"
-outfile="$destdir/$(basename "$infile")"
-tmpdir="$(tempfile -p 'pal-')"
-rm "$tmpdir"
+function main {
+    local infile="$1"
+    local outfile="$2"
 
-if [ -f "$outfile" ]; then
-       echo "Not overwriting $outfile"
-       exit 0
-fi
+    local tmpdir=""
+    tmpdir="$(mktemp -d "${TMPDIR:-/var/tmp}/pal-XXXXXXXX")"
+    local audiofile="${tmpdir}/audiofile.m4a"
+
+    encode_audio "$infile" "$audiofile"
+    remux_file "$infile" "$audiofile" "$outfile"
+
+    rm -rf "$tmpdir"
+}
+
+function encode_audio {
+    ffmpeg \
+        -i "$1" \
+        -vn \
+        "${SLOWFILTER[@]}" \
+        -c:a libfdk_aac -vbr 3 \
+        "$2"
+}
+
+function remux_file {
+    local infile="$1"
+    local audiofile="$2"
+    local outfile="$3"
+
+    local audiodelay=""
+    audiodelay="$(get_minimum_timestamp "$infile" "audio")"
+
+    local videodelay=""
+    videodelay="$(get_minimum_timestamp "$infile" "video")"
+
+    local videotrackid=""
+    videotrackid="$(get_track_id "$infile" "video")"
+
+    local suboptions=()
+    local subtitletrackid=""
+    while read -r subtitletrackid; do
+        suboptions+=("--sync" "${subtitletrackid}:0,${OLDFPS}/${NEWFPS}")
+    done < <(get_track_id "$infile" "subtitles")
+
+    local chapteroptions=()
+    if [ "$(get_chapter_count "$infile")" -gt 0 ]; then
+        chapteroptions=("--chapter-sync" "0,${OLDFPS}/${NEWFPS}")
+    fi
+
+    mkvmerge \
+        -o "${outfile}" \
+        --default-duration "${videotrackid}:${NEWFPS}fps" \
+        --sync "${videotrackid}:$((videodelay / 1000000))" \
+        "${chapteroptions[@]}" \
+        "${suboptions[@]}" \
+        --no-audio "$infile" \
+        --sync "0:$((audiodelay / 1000000))" \
+        "$audiofile"
+}
+
+function get_track_id {
+    mkvmerge -i -F json "$1" | jq -r ".tracks[] | select(.type == \"$2\") | .id"
+}
 
-set -x
-mkdir "$tmpdir"
-mkvextract tracks "$infile" 2:"${tmpdir}/audio"
-mplayer -ao pcm:file="${tmpdir}/audio.wav" -vo null "${tmpdir}/audio"
-sox "${tmpdir}/audio.wav" "${tmpdir}/audio-fixed.wav" speed "${SLOWDOWN}" gain -n
-lame --preset standard "${tmpdir}/audio-fixed.wav" "${tmpdir}/audio.mp3"
-mkvmerge -o "${outfile}" --default-duration "1:${FORCEFPS}fps" --no-audio "$infile" "${tmpdir}/audio.mp3"
+function get_minimum_timestamp {
+    mkvmerge -i -F json "$1" | jq -r ".tracks[] | select(.type == \"$2\") | .properties.minimum_timestamp"
+}
 
-rm -rf "$tmpdir"
+function get_chapter_count {
+    mkvmerge -i -F json "$1" | jq -r ".chapters | length"
+}
 
+main "$@"